﻿var ad_active = true;
var ad_state = "MAIDEN";
var ad_timer = null;
var ad_type = 0;            // 0 = AppsMarK, 1 = Interstitial, 2-10 = Internal ads
var admobid = {};

function adStatemachine(event) {
    "use strict";
    if (ad_active) {
        //    debugMessage(ad_state + "   " + event);
        switch (ad_state) {
            case "MAIDEN":
                switch (event) {
                    case "INIT":
                        ad_state = "INITIALISED";
                        adSetOptions();
                        adWait(1);
                        break;
                    default:
                        debugMessage("UNEXP " + ad_state + "  " + event);
                }
                break;
            case "INITIALISED":
                ad_state = "LOAD_AD";
                adPrepareInterstitial();
                break;
            case "LOAD_AD":
                switch (event) {
                    case "onAdPresent":
                        ad_state = "AD_AVAILABLE";
                        ad_type = 1;
                        break;
                    case "onAdLoaded":
                        ad_state = "AD_AVAILABLE";
                        ad_type = 1;
                        //                   adShowInterstitial();
                        break;
                    case "onAdFailLoad":
                        ad_state = "SHOW_DEFAULT_AD";
                        ad_type = 0;
                        //                   uiToPage("id_page_ad_default");
                        //                   adWait(5);
                        break;
                    default:
                        debugMessage("UNEXP " + ad_state + "  " + event);
                }
                break;
            case "AD_AVAILABLE":
                switch (event) {
                    //                case "onAdLoaded":
                    //                  ad_state = "SHOW_AD";
                    //                adShowInterstitial();
                    //              break;
                    case "onAdFailLoad":
                        ad_state = "SHOW_DEFAULT_AD";
                        ad_type = 0;
                        break;
                    case "SHOW_AD":
                        ad_state = "SHOW_AD";
                        adShowInterstitial();
                        break;
                    default:
                        debugMessage("UNEXP " + ad_state + "  " + event);
                }
                break;
            case "SHOW_AD":
                switch (event) {
                    case "onAdDismiss":
                        ad_state = "LOAD_AD";
                        adPrepareInterstitial();
                        break;
                    case "onAdPresent":
                        break;
                    case "onAdLeaveApp":
                        break;
                    default:
                        debugMessage("UNEXP " + ad_state + "  " + event);
                }
                break;
            case "SHOW_DEFAULT_AD":
                switch (event) {
                    case "SHOW_AD":
                        //                   uiToPage("id_page_ad_default");
                        //                    adWait(5);
                        adWait(1);
                        break;
                    case "TIMEOUT":
                        ad_state = "LOAD_AD";
                        uiToPage("id_logo_page_game");
                        adPrepareInterstitial();
                        break;
                    default:
                        debugMessage("UNEXP " + ad_state + "  " + event);
                }
                break;
            default:
                debugMessage("UNEXP " + ad_state + "  " + event);
        }
    }
}

function adInit() {
    "use strict";
    ad_state = "MAIDEN";
    adStatemachine("INIT");
}

function adSetOptions() {
    "use strict";
    var defaultOptions = {
        bannerId: admobid.interstitial,
        // interstitialId: admobid.interstitial,
        // adSize: 'SMART_BANNER',
        // width: integer,      // valid when set adSize 'CUSTOM'
        // height: integer,     // valid when set adSize 'CUSTOM'
        //position: AdMob.AD_POSITION.BOTTOM_CENTER,
        // offsetTopBar: false, // avoid overlapped by status bar, for iOS7+
        // bgColor: 'black',    // color name, or '#RRGGBB'
        // x: integer,          // valid when set position to 0 / POS_XY
        // y: integer,          // valid when set position to 0 / POS_XY
 //       isTesting: true       // set to true, to receiving test ad for testing purpose
        // autoShow: true       // auto show interstitial ad when loaded, set to false if prepare/show
    };
    if (/(android)/i.test(navigator.userAgent)) {
        admobid = {
            interstitial: 'ca-app-pub-9215942032557496/4321299961'
        };
    } else if (/(ipod|iphone|ipad)/i.test(navigator.userAgent)) {
        admobid = {
            interstitial: 'ca-app-pub-9215942032557496/1812476764'
        };
    }

//    debugMessage("going to default options")
    AdMob.setOptions(defaultOptions);
  //  debugMessage("going to register")
    registerAdEvents();
    //debugMessage("registered")
}

// optional, in case respond to events or handle error
function registerAdEvents() {
    "use strict";
    document.addEventListener('onAdFailLoad', function (data) {
//        debugMessage('error: ' + data.error + ', reason: ' + data.reason + ', adNetwork:' + data.adNetwork + ', adType:' + data.adType + ', adEvent:' + data.adEvent);
        adStatemachine("onAdFailLoad");
    });
    document.addEventListener('onAdLoaded', function (data) {
//        debugMessage('adNetwork:' + data.adNetwork + ', adType:' + data.adType + ', adEvent:' + data.adEvent);
        adStatemachine("onAdLoaded");
    });
    document.addEventListener('onAdPresent', function (data) {
//        debugMessage('adNetwork:' + data.adNetwork + ', adType:' + data.adType + ', adEvent:' + data.adEvent);
        adStatemachine("onAdPresent");
    });
    document.addEventListener('onAdLeaveApp', function (data) {
//        debugMessage('adNetwork:' + data.adNetwork + ', adType:' + data.adType + ', adEvent:' + data.adEvent);
        adStatemachine("onAdLeaveApp");
    });
    document.addEventListener('onAdDismiss', function (data) {
//        debugMessage('adNetwork:' + data.adNetwork + ', adType:' + data.adType + ', adEvent:' + data.adEvent);
        adStatemachine("onAdDismiss");
    });

}

function adPrepareInterstitial() {
    "use strict";
    if (on_pc) {
        adStatemachine("onAdLoaded");
    } else {
//        debugMessage("prepare")
        AdMob.prepareInterstitial({adId: admobid.interstitial, autoShow: false});
//        debugMessage("prepared")
    }
}


function adShowInterstitial() {
    "use strict";
    if (!on_pc) {
        AdMob.showInterstitial();
    }
}


function adWait(seconds) {
    "use strict";
    clearInterval(ad_timer);
    ad_timer = setTimeout(function () {
        adStatemachine("TIMEOUT");
    }, seconds * 1000);
}

