﻿var iap = {};

function iapFullVersion() {
    "use strict";
    store.order("full version");
}

// initialize the purchase plugin if available
function iapInit() {
    "use strict";
    if (!window.store) {
        debugMessage("Store not available");
        return;
    }

    store.register({
        id: "fullversion",
        alias: "full version",
        type: store.NON_CONSUMABLE
    });

    // When any product gets updated
    store.when("product").updated(function (p) {
        debugMessage("Price = " + p.price);
    });

    // Log all errors
    store.error(function (error) {
        switch (error.code) {
        case store.ERR_SETUP:
            alert("NOT SIGNED INTO YOUR GOOGLE ACCOUNT");
            break;
        case store.ERR_PURCHASE:
            alert("PURCHASE FAILED");
            break;
        }
    });

    // When purchase of the full version is approved
    store.when("full version").approved(function (order) {
        debugMessage("Unlocked the FULL VERSION!");
        ad_active = false;
        order.finish();
    });

    // The play button can only be accessed when the user owns the full version.
    store.when("full version").updated(function (product) {
        debugMessage("full version updated");
        if (product.owned) {
            ad_active = false;
        }
    });

    // Note that the "ready" function will be called immediately if the store
    // is already ready.
    store.ready(function () {
        debugMessage("store ready");
    });

    // Refresh the store.
    // This will contact the server to check all registered products validity and ownership status.
    store.refresh();
}


// make sure fn will be called with iap as "this"
iap.bind = function (fn) {
    "use strict";
    return function () {
        fn.call(iap, arguments);
    };
};
