﻿var debug_enabled = false;
var on_pc = false;
var test_mode = false;

var app = {
    // Application Constructor
    initialize: function () {
        "use strict";
        if (isMobile.any()) {
            this.bindEvents();
        } else {
            initApp();
        }
    },
    // Bind Event Listeners
    bindEvents: function () {
        "use strict";
        document.addEventListener("deviceready", this.onDeviceReady, false);
    },
    // deviceready Event Handler
    onDeviceReady: function () {
        "use strict";
        FastClick.attach(document.body);
        initApp();
    }
};

var isMobile = {
    Android: function () {
        "use strict";
        return navigator.userAgent.match(/Android/i);
    },
    iOS: function () {
        "use strict";
        return navigator.userAgent.match(/iPhone|iPad|iPod/i);
    },
    Windows: function () {
        "use strict";
        return navigator.userAgent.match(/IEMobile/i);
    },
    any: function () {
        "use strict";
        return (isMobile.Android() || isMobile.iOS() || isMobile.Windows());
    }
};

function debugMessage(message) {
    "use strict";
    if (debug_enabled) {
        alert(message);
    }
}

function initApp() {
    "use strict";
    if (isMobile.any() === null) {
        on_pc = true;
    }
    uiHideSplashScreen();
    uiInit();
    gameInit();
    if (!on_pc) {
        if (!AdMob) {
            debugMessage("admob plugin not ready");
            return;
        }
    }
    adInit();
    iapInit();
}