﻿var logo_button = [0, 0, 0, 0];     // Pointer to logo
var logo_button_enabled = false;    // Enable/disable button presses
var logo_button_maximum = 4;        // Number of brand buttons
var logo_event = null;              // Event for statemachine
var logo_index_button_ist = 0;      // Index button currently pressed
var logo_index_button_soll = -1;    // Index button linked with color shown
var logo_state = "MAIDEN";          // State
var logo_timeout = 200;             // Time color shown
var logo_timeout_count;             // Number of times timeout occurred
var logo_timer;                     // Timer for logo game
var logo_turns = 0;                 // Number of turns played

var logo_mode = 0;                  // 0 = step, 1 = slow, 2 = fast
var logo_commercial = -4;           // Number of errors before showing ads
var logo_commercial_maximum = 4;    // Maximum number of errors before showing ads

function logoButtonBuyClicked() {
    "use strict";
    iapFullVersion();
}

function logoHideLogo() {
    "use strict";
    document.getElementById("id_logo_picture").style.opacity = 0;
    document.getElementById("id_logo_picture").style.width = "0px";
    document.getElementById("id_logo_background").style.backgroundColor = "lightgrey";
}

function logoRandomLogo() {
    "use strict";
    var index = -1;
    do {
        if (test_mode) {
            index += 1;
        } else {
            index = Math.floor(logo_data_maximum * Math.random());
        }
    } while ((logo_data[index][0] === 1) || (logo_data[index][0] === 2));
    logo_data[index][0] = 1;
    return index;
}

function logoAssureAvailableLogos() {
    "use strict";
    var count = 0;
    var available = 0;
    var index;
    for (index = 0; index < logo_data_maximum; index += 1) {
        if (logo_data[index][0] === 0) {
            count += 1;
        }
    }
    if (count < logo_button_maximum) {
        for (index = 0; index < logo_data_maximum; index += 1) {
            if (logo_data[index][0] === 1) {
                logo_data[index][0] = 0;
            }
        }
        for (index = 0; index < logo_data_maximum; index += 1) {
            if (logo_data[index][0] === 0) {
                available += 1;
            }
        }
        if (available < logo_button_maximum) {
            for (index = 0; index < logo_data_maximum; index += 1) {
                logo_data[index][0] = 0;
            }
        }
    }
}

function logoRefreshButtons() {
    "use strict";
    var brand;
    var index;
    var index_logo;

    logoAssureAvailableLogos();
    for (index = 0; index < logo_button_maximum; index += 1) {
        index_logo = logoRandomLogo();
        logo_button[index] = index_logo;
        brand = logo_data[index_logo][1];
        if (brand.search("n") !== -1) {
            brand = brand.replace("n", "&");
        }
        if (brand.search("_") !== -1) {
            brand = brand.replace("_", " ");
        }
        if (brand.search("p") !== -1) {
            brand = brand.replace("p", ".");
        }
        document.getElementById("id_logo_button" + index).innerHTML = brand;
        document.getElementById("id_logo_button" + index).style.backgroundColor = ui_logo_button_background_released;
    }
}

function logoRandomColor(index_logo) {
    "use strict";
    var logo_index_color;   // Index current color
    var result;
    do {
        logo_index_color = 3 * Math.floor(logo_data_color_maximum * Math.random());
    } while (logo_data[index_logo][logo_index_color + 3] === undefined);
    result = "rgb(" + logo_data[index_logo][logo_index_color + 3] + "," + logo_data[index_logo][logo_index_color + 4] + "," + logo_data[index_logo][logo_index_color + 5] + ")";
    return result;
}

function logoShowColor(id) {
    "use strict";
    document.getElementById("id_logo_background").style.backgroundColor = logoRandomColor(id);
}

function logoNextColor() {
    "use strict";
    var logo_index_button_soll_old;
    logo_turns += 1;
    // Prevent selecting current color
    logo_index_button_soll_old = logo_index_button_soll;
    do {
        logo_index_button_soll = Math.floor(logo_button_maximum * Math.random());
    } while (logo_index_button_soll === logo_index_button_soll_old);
    if (test_mode) {
        logo_index_button_soll = 0;
        document.getElementById("id_logo_background").style.backgroundColor = "red"; //"rgb(" + logo_data[index_logo][3] + "," + logo_data[index_logo][4] + "," + logo_data[index_logo][5] + ")";
    } else {
        logoShowColor(logo_button[logo_index_button_soll]);
    }
}

function logoHideColor() {
    "use strict";
    document.getElementById("id_logo_background").style.backgroundColor = "lightgrey";
}

function logoSizeLogo() {
    "use strict";
    var element = document.getElementById("id_logo_picture");
    if (Math.abs(element.naturalWidth - element.naturalHeight) < 0.1 * ui_height) {
        element.style.height = ui_logo_height + "px";
        element.style.width = ui_logo_height + "px";
    } else {
        element.style.width = (0.9 * ui_width) + "px";
    }
    element.style.opacity = 1;
}

function logoReleaseAllButtons() {
    "use strict";
    var index;
    for (index = 0; index < 3; index += 1) {
        document.getElementById("id_logo_button" + index).style.backgroundColor = ui_logo_button_background_released;
    }
}

function logoReleaseButton() {
    "use strict";
    document.getElementById("id_logo_button" + logo_index_button_ist).style.backgroundColor = ui_logo_button_background_released;
}

function logoStatemachine() {
    "use strict";
    var logo_state_old = logo_state;
    logo_timeout_count += 1;
    switch (logo_state) {
    case "MAIDEN":
        logoUiInit();
        logoDataInit();
        uiHideSplashScreen();
        uiToPage("id_logo_page_game");
        logo_state = "SHOW_QUESTION_MARK";
        break;
    case "SHOW_QUESTION_MARK":
        if (logo_timeout_count > 5) {
            logoHideLogo();
            logo_state = "RESET";
        }
        break;
    case "RESET":
        logoDataReset();
        document.getElementById("id_logo_ok").style.width = "0px";
        logoRefreshButtons();
        logo_state = "READY";
        break;
    case "READY":
        if (logo_timeout_count > 5) {
            logoNextColor();
            logo_button_enabled = true;
            logo_state = "SHOW_COLOR";
            logo_data_tries += 1;
        }
        break;
    case "SHOW_COLOR":
        switch (logo_event) {
        case "CORRECT":
            document.getElementById("id_logo_button" + logo_index_button_ist).style.backgroundColor = ui_logo_button_background_pressed;
            logo_data_correct += 1;
            if (logo_data_correct >= logo_data_target) {
                document.getElementById("id_logo_ok").style.width = ui_width + "px";
                logo_state = "FINISHING";
            } else {
                document.getElementById("id_logo_ok").style.width = logo_data_correct * (ui_width / logo_data_target) + "px";
                logo_state = "SIZE_CORRECT";
            }
            break;
        case "INCORRECT":
            document.getElementById("id_logo_button" + logo_index_button_ist).style.backgroundColor = ui_logo_button_background_wrong;
            logo_state = "SIZE_INCORRECT";
            break;
        }
        break;
    case "SIZE_CORRECT":
        logoSizeLogo();
        if (logo_timeout_count > 1) {
            logoHideColor();
            logo_state = "SHOW_CORRECT";
        }
        break;
    case "SHOW_CORRECT":
        if (logo_timeout_count > 5) {
            logo_state = "HIDING_LOGO";
        }
        break;
    case "HIDING_LOGO":
        logoHideColor();
        if (logo_timeout_count > 0) {
            logoHideLogo();
            logoRefreshButtons();
            logo_state = "READY";
        }
        break;
    case "SIZE_INCORRECT":
        logoSizeLogo();
        if (logo_timeout_count > 1) {
            logo_state = "SHOW_INCORRECT";
        }
        break;

    case "SHOW_INCORRECT":
        if (logo_timeout_count > 5) {
            logoHideColor();
            logo_state = "SHOW_WRONG_LOGO";
        }
        break;
    case "SHOW_WRONG_LOGO":
        if (logo_timeout_count > 5) {
            logoHideLogo();
            logoHideColor();
            logo_commercial += 1;
            if (logo_commercial > logo_commercial_maximum) {
                logo_state = "COMMERCIAL";
                logo_commercial = 0;
                logoReleaseAllButtons();
                adStatemachine("SHOW_AD");
            } else {
                logoReleaseButton();
                logo_state = "READY";
            }
        }
        break;
    case "COMMERCIAL":
        if (logo_timeout_count > 5) {
            uiFlipToPage("id_logo_page_game");
            logoReleaseButton();
            logo_state = "READY";
        }
        break;
    case "FINISHING":
        logoSizeLogo();
        if (logo_timeout_count > 10) {
            if (logo_data_tries === logo_data_target) {
                document.getElementById("id_score").innerHTML = logo_data_score_string_3 + logo_data_target + logo_data_score_string_4;
                document.getElementById("id_button_text").innerHTML = logo_data_button_string_2;
                logo_data_target += 5;
                if (logo_data_target > (logo_data_maximum - logo_button_maximum + 1)) {
                    logo_data_target = logo_data_maximum - logo_button_maximum + 1;
                }
            } else {
                document.getElementById("id_score").innerHTML = logo_data_target + logo_data_score_string_1 + logo_data_tries + logo_data_score_string_2;
                document.getElementById("id_button_text").innerHTML = logo_data_button_string_1;
            }
            logoHideLogo();
            logoHideColor();
            logo_state = "FINISHED";
        }
        break;
    case "FINISHED":
        if (logo_timeout_count > 5) {
            uiToPage("id_logo_page_score");
            logo_state = "WAIT_FOR_RESTART";
        }
        break;
    case "WAIT_FOR_RESTART":
        break;
    default:
        if (logo_event === null) {
            debugMessage(logo_state);
            logo_state = "RESET";
        }
    }
    logo_event = null;
    if (logo_state !== logo_state_old) {
        logo_timeout_count = 0;
    }
}

function logoShowLogo(id) {
    "use strict";
    var element = document.getElementById("id_logo_picture");
    element.src = "images/logo/" + logo_data[id][1] + ".png";
    element.style.width = "0px";
    element.style.opacity = 1;
}

function logoButtonClicked(id) {
    "use strict";
    if (logo_button_enabled) {
        logo_button_enabled = false;
        logo_index_button_ist = parseInt(id.substring(14));
        logoShowLogo(logo_button[logo_index_button_ist]);
        if (logo_index_button_ist === logo_index_button_soll) {
            logo_data[logo_button[logo_index_button_ist]][0] = 2;
            logo_event = "CORRECT";
        } else {
            logo_event = "INCORRECT";
        }
        logoStatemachine();
    }
}

function gameInit() {
    "use strict";
    clearInterval(logo_timer);
    logo_timer = setInterval(logoStatemachine, logo_timeout);
}

function logoButtonStartClicked() {
    "use strict";
    uiToPage("id_logo_page_game");
    logo_state = "RESET";
    clearInterval(logo_timer);
    logo_timer = setInterval(logoStatemachine, logo_timeout);
}
